/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.deepexi.scd.common.system.AppRuntimeEnv
 *  com.deepexi.util.JsonUtil
 *  org.apache.rocketmq.client.producer.DefaultMQProducer
 *  org.apache.rocketmq.client.producer.SendCallback
 *  org.apache.rocketmq.client.producer.SendResult
 *  org.apache.rocketmq.common.message.Message
 */
package com.deepexi.scd.calculate.mq.producer;

import com.deepexi.scd.common.system.AppRuntimeEnv;
import com.deepexi.util.JsonUtil;
import java.nio.charset.StandardCharsets;
import org.apache.rocketmq.client.producer.DefaultMQProducer;
import org.apache.rocketmq.client.producer.SendCallback;
import org.apache.rocketmq.client.producer.SendResult;
import org.apache.rocketmq.common.message.Message;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class RocketMQProducer {
    private static final Logger log = LoggerFactory.getLogger(RocketMQProducer.class);
    private DefaultMQProducer defaultMQProducer;
    private AppRuntimeEnv appRuntimeEnv;

    public void sendToMetaDataHandler(Object event, final String topic, String tag) {
        Message message = new Message(topic, tag, JsonUtil.bean2JsonString((Object)event).getBytes(StandardCharsets.UTF_8));
        try {
            this.setMessageRuntimeEnv(message);
            this.defaultMQProducer.send(message, new SendCallback(){

                public void onSuccess(SendResult sendResult) {
                    log.info("############【发送MQ发送成功,topic:{} messageId:{}】###############", (Object)topic, (Object)sendResult.getMsgId());
                }

                public void onException(Throwable e) {
                    log.error("###########【订单MQ发送失败:{}】###############", e);
                }
            });
        }
        catch (InterruptedException e) {
            log.error("发送数据到MQ失败", e);
            Thread.currentThread().interrupt();
        }
        catch (Exception e) {
            log.error("发送数据到MQ失败", e);
        }
    }

    private void setMessageRuntimeEnv(Message message) {
        message.getProperties().put("tenantId", this.appRuntimeEnv.getTenantId());
        if (this.appRuntimeEnv.getAppId() != null) {
            message.getProperties().put("appId", this.appRuntimeEnv.getAppId().toString());
        }
        message.getProperties().put("userId", this.appRuntimeEnv.getUserId());
        message.getProperties().put("username", this.appRuntimeEnv.getUserName());
    }

    public RocketMQProducer(DefaultMQProducer defaultMQProducer, AppRuntimeEnv appRuntimeEnv) {
        this.defaultMQProducer = defaultMQProducer;
        this.appRuntimeEnv = appRuntimeEnv;
    }

    public RocketMQProducer() {
    }
}

